# Generated by Django 2.0.5 on 2021-03-24 11:22

import custom_storages
from django.conf import settings
import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion
import project_management.models.project


class Migration(migrations.Migration):

    replaces = [('project_management', '0005_auto_20210315_1152'), ('project_management', '0006_customertouchmeetingtemplate_email_subject'), ('project_management', '0007_auto_20210324_0652'), ('project_management', '0008_auto_20210324_1023'), ('project_management', '0009_additionalsetting')]

    dependencies = [
        ('accounts', '0092_auto_20210322_1207'),
        ('project_management', '0002_auto_20210302_1304_squashed_0005_auto_20210311_0708'),
        ('accounts', '0091_auto_20210311_0708'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='CustomerTouchMeetingTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True)),
                ('updated_on', models.DateTimeField(auto_now=True)),
                ('message_html', models.TextField()),
                ('message_markdown', models.TextField()),
                ('last_updated_by', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to=settings.AUTH_USER_MODEL)),
                ('provider', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='customer_touch_meeting_template', to='accounts.Provider')),
                ('email_subject', models.CharField(max_length=500, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='KickoffMeetingTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True)),
                ('updated_on', models.DateTimeField(auto_now=True)),
                ('template_name', models.CharField(max_length=150)),
                ('action_items', django.contrib.postgres.fields.ArrayField(base_field=models.TextField(), size=None)),
                ('agenda_topics', django.contrib.postgres.fields.ArrayField(base_field=models.TextField(), size=None)),
                ('last_updated_by', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to=settings.AUTH_USER_MODEL)),
                ('provider', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='kickoff_meeting_templates', to='accounts.Provider')),
            ],
        ),
        migrations.AlterUniqueTogether(
            name='kickoffmeetingtemplate',
            unique_together={('provider', 'template_name')},
        ),
        migrations.CreateModel(
            name='Document',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True)),
                ('updated_on', models.DateTimeField(auto_now=True)),
                ('file_name', models.CharField(max_length=200)),
                ('file_path', models.FileField(blank=True, null=True, storage=custom_storages.OverwriteStorage(), upload_to=project_management.models.project.file_upload_url)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True)),
                ('updated_on', models.DateTimeField(auto_now=True)),
                ('title', models.CharField(max_length=500)),
                ('description', models.TextField(blank=True, null=True)),
                ('crm_id', models.IntegerField(null=True)),
                ('hours_budget', models.PositiveIntegerField(default=0)),
                ('actual_hours', models.PositiveIntegerField(default=0)),
                ('estimated_end_date', models.DateTimeField(null=True)),
                ('closed_date', models.DateTimeField(null=True)),
                ('account_manager', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('board', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name='projects', to='project_management.ProjectBoard')),
                ('customer', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='projects', to='accounts.Customer')),
                ('last_updated_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('overall_status', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='projects', to='project_management.OverallStatusSetting')),
                ('primary_contact', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('project_manager', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='projects', to=settings.AUTH_USER_MODEL)),
                ('provider', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='projects', to='accounts.Provider')),
                ('type', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='projects', to='project_management.ProjectType')),
            ],
        ),
        migrations.AddField(
            model_name='document',
            name='project',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='documents', to='project_management.Project'),
        ),
        migrations.AddField(
            model_name='document',
            name='uploaded_by',
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddIndex(
            model_name='project',
            index=models.Index(fields=['provider', 'project_manager'], name='project_man_provide_caafb1_idx'),
        ),
        migrations.AddIndex(
            model_name='project',
            index=models.Index(fields=['provider', 'crm_id'], name='project_man_provide_d779c5_idx'),
        ),
        migrations.AddIndex(
            model_name='project',
            index=models.Index(fields=['provider', 'customer'], name='project_man_provide_82faa5_idx'),
        ),
        migrations.AddIndex(
            model_name='project',
            index=models.Index(fields=['provider', 'board'], name='project_man_provide_5b314e_idx'),
        ),
        migrations.AlterField(
            model_name='project',
            name='actual_hours',
            field=models.FloatField(default=0),
        ),
        migrations.AlterField(
            model_name='project',
            name='hours_budget',
            field=models.FloatField(default=0),
        ),
        migrations.AlterUniqueTogether(
            name='project',
            unique_together={('provider', 'crm_id')},
        ),
        migrations.CreateModel(
            name='AdditionalSetting',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True)),
                ('updated_on', models.DateTimeField(auto_now=True)),
                ('default_project_manager', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('provider', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='additional_project_settings', to='accounts.Provider')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EngineerRoleMapping',
            fields=[
                ('id',
                 models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('role_ids',
                 django.contrib.postgres.fields.ArrayField(base_field=models.IntegerField(), size=None)),
            ],
        ),
        migrations.AlterUniqueTogether(
            name='overallstatussetting',
            unique_together={('provider', 'title', 'board')},
        ),
        migrations.AddField(
            model_name='engineerrolemapping',
            name='provider',
            field=models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='accounts.Provider'),
        ),
    ]
